#include <gtk/gtk.h>
#include <glib.h>
#include <popt.h>
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>

#include "defs.h"
#include "config.h"

void hello (GtkWidget * widget, OPTIONS *data) {
	gchar *name;
	GString *number;
	gint i;
	
	name = gtk_widget_get_name(widget);
	i = (data->number)->len - 1;
	while(i>= 0) {
		number = g_ptr_array_index(data->number, i);
		if(strcmp(number->str, name) == 0) {
			data->clicked_button = atoi(number->str);
			i = 0;
		}
		i--;
	}
	
}

void destroy (GtkWidget * widget, OPTIONS *data) {
	gtk_main_quit ();
}

void make_gui(OPTIONS *my_options) {

	GtkWidget	*window;
	GtkWidget	*vbox;
	GtkWidget	*hbox;
	GtkWidget	*message;
	GtkWidget	*button;
	int		i;
	GString		*button_string;
	GString		*button_number;
	gint		win_x, win_y;
	guint		win_w, win_h;


	/* create a new window */
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_position(GTK_WINDOW(window),my_options->win_position);
	gtk_window_set_title(GTK_WINDOW(window),(my_options->win_title)->str);
	win_x = -1;
	win_y = -1;
	win_h = -1;
	win_w = -1;
	if(my_options->geometry) {
		XParseGeometry((my_options->geometry)->str,&win_x, &win_y, &win_w, &win_h);
	}

	gtk_signal_connect (GTK_OBJECT (window), "destroy",
		GTK_SIGNAL_FUNC (destroy), my_options);
		
	vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_add (GTK_CONTAINER (window), vbox);
	
        message = gtk_text_new (NULL, NULL);
        gtk_text_insert (GTK_TEXT(message), NULL, NULL, NULL, (my_options->message)->str, -1);

	gtk_box_pack_start(GTK_BOX(vbox), message, TRUE, TRUE, 2);


	hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 2);
	
	for(i=0; i<my_options->label->len; i++) {
		button_string = g_ptr_array_index(my_options->label, i);
		button = gtk_button_new_with_label(button_string->str);

		button_number = g_ptr_array_index(my_options->number, i);
		gtk_widget_set_name(button, button_number->str);

		gtk_signal_connect (GTK_OBJECT (button), "clicked",
			GTK_SIGNAL_FUNC (hello), my_options);

		gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			GTK_SIGNAL_FUNC (gtk_widget_destroy),
			GTK_OBJECT (window));

		gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 2);
		gtk_widget_show (button);
	}


	if((win_w >= 0) && (win_h >= 0)) {
		gtk_window_set_default_size(GTK_WINDOW(window), win_w, win_h);
	}
	if((win_x >= 0) && (win_y >= 0)) {
		gtk_widget_set_uposition(window, win_x, win_y);
	}

	gtk_widget_show (hbox);
	gtk_widget_show (message);
	gtk_widget_show (vbox);
	gtk_widget_show (window);
	
}
